CREATE TABLE T_Order(
    morderId INTEGER NOT NULL UNIQUE,
    minvoiceId integer UNIQUE,
    FOREIGN KEY (minvoiceId) REFERENCES T_Invoice,
    mcustomerId INTEGER NOT NULL UNIQUE,
    FOREIGN KEY (mcustomerId) REFERENCES T_Customer,
    PRIMARY KEY(morderId))
go 
 
 
CREATE TABLE T_OrderSummary(
    morderSummaryId integer NOT NULL UNIQUE,
    mdiscount float NOT NULL,
    mcourtesyMessage VARCHAR(50) NOT NULL,
    morderId INTEGER NOT NULL UNIQUE,
    FOREIGN KEY (morderId) REFERENCES T_Order,
    PRIMARY KEY(morderSummaryId))
go 
 
 
CREATE TABLE T_OrderLine(
    mquantity integer NOT NULL,
    mdiscount float NOT NULL,
    mextendedUnitPrice float NOT NULL,
    morderLineId INTEGER NOT NULL UNIQUE,
    mproductId integer NOT NULL UNIQUE,
    FOREIGN KEY (mproductId) REFERENCES T_Product,
    morderId INTEGER NOT NULL UNIQUE,
    FOREIGN KEY (morderId) REFERENCES T_Order,
    PRIMARY KEY(morderLineId))
go 
 
 
CREATE TABLE T_OrderHeader(
    morderdatetime datetime NOT NULL,
    mterms VARCHAR(30) NOT NULL,
    msalesPerson VARCHAR(20) NOT NULL,
    morderHeaderId INTEGER NOT NULL UNIQUE,
    morderId INTEGER NOT NULL UNIQUE,
    FOREIGN KEY (morderId) REFERENCES T_Order,
    PRIMARY KEY(morderHeaderId))
go 
 
 
CREATE TABLE T_Shipment(
    mshipmentId Integer NOT NULL UNIQUE,
    mshipmentdatetime datetime NOT NULL,
    PRIMARY KEY(mshipmentId))
go 
 
 
CREATE TABLE T_Product(
    mproductId integer NOT NULL UNIQUE,
    mdescription VARCHAR(50) NOT NULL,
    mprice float NOT NULL,
    mdiscount float NOT NULL,
    mquantityOnHand integer NOT NULL,
    meoq integer NOT NULL,
    mrefproductId integer NULL UNIQUE,
    PRIMARY KEY(mproductId))
go 
 
 
CREATE TABLE T_Guitar(
    mstringCount INTEGER NOT NULL,
    mright Char(3) NOT NULL,
    mfretLess CHAR(3) NOT NULL,
    mmake VARCHAR(20) NOT NULL,
    mmodel VARCHAR(20) NOT NULL,
    mage INTEGER NOT NULL,
    mproductId integer NOT NULL UNIQUE,
    FOREIGN KEY (mproductId) REFERENCES T_Product,
    mguitarId INTEGER NOT NULL UNIQUE,
    PRIMARY KEY(mguitarId))
go 
 
 
CREATE TABLE T_SheetMusic(
    msheetId INTEGER NOT NULL UNIQUE,
    mpages INTEGER NOT NULL,
    mproductId integer NOT NULL UNIQUE,
    FOREIGN KEY (mproductId) REFERENCES T_Product,
    PRIMARY KEY(msheetId))
go 
 
 
CREATE TABLE T_Supplies(
    msupplyId INTEGER NOT NULL UNIQUE,
    mindependent CHAR(3) NOT NULL,
    mproductId integer NOT NULL UNIQUE,
    FOREIGN KEY (mproductId) REFERENCES T_Product,
    PRIMARY KEY(msupplyId))
go 
 
CREATE VIEW Guitar_V(
    mstringCount,
    mright,
    mfretLess,
    mmake,
    mmodel,
    mage,
    mguitarId,
    mproductId,
    mdescription,
    mprice,
    mdiscount,
    mquantityOnHand,
    meoq)

    AS SELECT
    T_Guitar.mstringCount,
    T_Guitar.mright,
    T_Guitar.mfretLess,
    T_Guitar.mmake,
    T_Guitar.mmodel,
    T_Guitar.mage,
    T_Guitar.mguitarId,
    T_Product.mproductId,
    T_Product.mdescription,
    T_Product.mprice,
    T_Product.mdiscount,
    T_Product.mquantityOnHand,
    T_Product.meoq
   
    FROM T_Guitar,T_Product
    WHERE T_Guitar.mproductId=T_Product.mproductId
go 
 
 
CREATE VIEW SheetMusic_V(
    mpages,
    msheetId,
    mproductId,
    mdescription,
    mprice,
    mdiscount,
    mquantityOnHand,
    meoq)
    
    AS SELECT
    T_SheetMusic.mpages,
    T_SheetMusic.msheetId,
    T_Product.mproductId,
    T_Product.mdescription,
    T_Product.mprice,
    T_Product.mdiscount,
    T_Product.mquantityOnHand,
    T_Product.meoq
    

    FROM T_SheetMusic,T_Product
    WHERE T_SheetMusic.mproductId=T_Product.mproductId
go 
 
 
CREATE VIEW Supplies_V(
    mindependent,
    msupplyId,
    mproductId,
    mdescription,
    mprice,
    mdiscount,
    mquantityOnHand,
    meoq)

    AS SELECT
    
    T_Supplies.mindependent,
    T_Supplies.msupplyId,
    T_Product.mproductId,
    T_Product.mdescription,
    T_Product.mprice,
    T_Product.mdiscount,
    T_Product.mquantityOnHand,
    T_Product.meoq
    

    FROM T_Supplies,T_Product
    WHERE T_Supplies.mproductId=T_Product.mproductId
go 
 
 
