VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 3  'UsesTransaction
END
Attribute VB_Name = "Access"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"36EC83BB0168"
Option Base 0
Option Explicit

'##ModelId=36F47DAC0230
Private moConn      As ADODB.Connection
'##ModelId=36F47DAC0264
Private mrsTemp     As ADODB.Recordset
Implements ObjectControl
'##ModelId=371244980106
Dim moInstanceInfo As InstanceUDT
'##ModelId=36F47DAC0265
Public Function DABeginTrans(Optional lErrNo As Long, Optional sErrDescr As String) As Boolean
    
    On Error GoTo DABeginTransErr
    
    DABeginTrans = False
    
    'begin transaction
    moConn.BeginTrans
    
    DABeginTrans = True
    
    Exit Function
    
DABeginTransErr:
    lErrNo = Err.Number
    sErrDescr = Err.Description
End Function
'##ModelId=36F0A1650104
Public Function DAClose(Optional lErrNo As Long, Optional sErrDescr As String) As Boolean
    On Error GoTo DACloseErr
    
    DAClose = False
        
    'Close the connection
    moConn.Close
        
    DAClose = True      'Return TRUE for function
    
    Exit Function
    
DACloseErr:
    lErrNo = Err.Number
    sErrDescr = Err.Description
End Function
'##ModelId=36F47DAC030C
Public Function DACommitTrans(Optional lErrNo As Long, Optional sErrDescr As String) As Boolean
    
    On Error GoTo DACommitTransErr
    
    DACommitTrans = False
    
    'commit the transaction
    moConn.CommitTrans
    
    DACommitTrans = True
    
    Exit Function
    
DACommitTransErr:
    lErrNo = Err.Number
    sErrDescr = Err.Description
End Function
'##ModelId=36F0A156021C
Public Function DAConnect(ByVal sConnect As String, Optional lErrNo As Long, Optional sErrDescr As String) As Boolean

    On Error GoTo DAConnectErr
        
    DAConnect = False
    
    'Get a new connection
    Set moConn = New ADODB.Connection
    
    'Call open method to open the DSN
    moConn.Open sConnect
    
    DAConnect = True      'Return TRUE for function
    Exit Function
DAConnectErr:
    lErrNo = Err.Number
    sErrDescr = Err.Description
End Function
'##ModelId=36F0A1290078
Public Function DAQuery(ByVal sQry As String, Optional ByVal sConnect As String, Optional lErrNo As Long, Optional sErrDescr As String) As Boolean
    On Error GoTo DAQueryErr

    DAQuery = False
    
    If Not GetStatus(sConnect) Then
       Exit Function
    End If

    'Execute the query
    moConn.Execute sQry

    If Not SetStatus() Then
       DAQuery = False
    Else
       DAQuery = True
    End If
    
    Exit Function
    
DAQueryErr:
    lErrNo = Err.Number
    sErrDescr = Err.Description
End Function
'##ModelId=36F09FE50258
Public Function DARetrieve(ByVal sQry As String, sTemp() As String, bAddColumnName As Boolean, Optional ByVal sConnect As String, Optional lErrNo As Long, Optional sErrDescr As String) As Boolean
 
    On Error GoTo DARetrieveErr
    
    Dim sRet        As String
    Dim lCurRow     As Long
    Dim iCols       As Integer
    Dim iCurCol     As Integer
        
    DARetrieve = False
    
    If Not GetStatus(sConnect) Then
       Exit Function
    End If
    
    Set mrsTemp = moConn.Execute(sQry)
        
    'Check the existence of records before filling up array
    If Not (mrsTemp.BOF And mrsTemp.EOF) Then
        iCols = mrsTemp.Fields.Count - 1
        'If meta data desired, go get it
        If bAddColumnName Then
            lCurRow = 0
            ReDim sTemp(iCols, lCurRow + 1)
            For iCurCol = 0 To iCols
                sTemp(iCurCol, lCurRow) = mrsTemp(iCurCol).Name
            Next iCurCol
            lCurRow = 1
        Else
            lCurRow = 0
        End If
        
        Do Until mrsTemp.EOF
            ReDim Preserve sTemp(iCols, lCurRow)
            For iCurCol = 0 To iCols
                If IsNull(mrsTemp(iCurCol)) Then
                    'For nulls, get default value
                    CheckType mrsTemp(iCurCol).Type, sRet
                    sTemp(iCurCol, lCurRow) = sRet
                Else
                    sTemp(iCurCol, lCurRow) = Trim$(CStr(mrsTemp(iCurCol)))
                End If
            Next iCurCol
            lCurRow = lCurRow + 1
            mrsTemp.MoveNext
        Loop
        DARetrieve = True
    End If
    
    mrsTemp.Close           'Close the recordset
    Set mrsTemp = Nothing   'Clear the recordset object
    
    Dim sFileName As String
    sFileName = App.Path & "\remulak.log"
    Open sFileName For Append As #1
    Print #1, sQry & vbCrLf
    Close #1
    
    If Not SetStatus() Then
       DARetrieve = False
    Else
       DARetrieve = True
    End If
       
    
    Exit Function           'Exit the function

DARetrieveErr:
    lErrNo = Err.Number
    sErrDescr = Err.Description
End Function
'##ModelId=36F47DAD0140
Public Function DARollBack(Optional lErrNo As Long, Optional sErrDescr As String) As Boolean
    
    On Error GoTo DARollBackErr
    
    DARollBack = False
    
    'rollback the transaction
    moConn.RollbackTrans
        
    If Not DAClose(lErrNo, sErrDescr) Then
       Exit Function
    End If
        
    DARollBack = True
    
    Exit Function
    
DARollBackErr:
    lErrNo = Err.Number
    sErrDescr = Err.Description
End Function
'##ModelId=36F47DAD01AE
Private Sub CheckType(ByVal lType As Long, sRet As String)

    'Assign the default value
    Select Case lType
        Case adDate, adDBDate, adDBTime, adDBTimeStamp
            sRet = 0

        Case adBigInt, adCurrency, adDecimal, adDouble, adInteger, adNumeric, adSingle, adSmallInt, adTinyInt, adUnsignedBigInt, adUnsignedInt, adUnsignedSmallInt, adUnsignedTinyInt

            sRet = 0
    End Select
End Sub
'##ModelId=3712449A02DA
Private Function GetStatus(ByVal sConnect As String) As Boolean
    
    GetStatus = False
    
    'MTS is Present
    If Not moInstanceInfo.objectContext Is Nothing Then
       If DAConnect(sConnect) Then
          GetStatus = True
       End If
    Else
       GetStatus = True
    End If
       
End Function
'##ModelId=3712449A0384
Private Function SetStatus() As Boolean
    SetStatus = False
    
    If Not moInstanceInfo.objectContext Is Nothing Then
       If DAClose() Then
          moInstanceInfo.objectContext.SetComplete
          SetStatus = True
       End If
    Else
        SetStatus = True
    End If
       
End Function

'##ModelId=36F47DAD021C
Private Sub Class_Terminate()
    Set moConn = Nothing
End Sub
'##ModelId=3712449B000A
Private Sub ObjectControl_Activate()
    Set moInstanceInfo.objectContext = GetObjectContext()
End Sub

'##ModelId=3712449B003C
Private Function ObjectControl_CanBePooled() As Boolean
    ObjectControl_CanBePooled = True
End Function
'##ModelId=3712449B0078
Private Sub ObjectControl_Deactivate()
    Set moInstanceInfo.objectContext = Nothing
End Sub
